/*
 * Simple implementation of sudo
 *
 * Note the highly secure way in which this program does not verify the
 * identity of the person who runs it.
 *
 * This implements path search semantics so that execve may be used, because
 * we want to pass the environment over too.
 *
 */
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

int main(int argc, char **argv, char **envp) {
    char *path = strdup(getenv("PATH"));
    if (argc == 1) return 1;
    setuid(geteuid());
    setgid(getegid());
    if (path && !strchr(argv[1], '/')) {
        char *d;
        char *s = (char*)malloc(strlen(path) + strlen(argv[1]) + 1);
        d = strtok(path, ":");
        while (d) {
            sprintf(s, "%s/%s", d, argv[1]);
            execve(s, argv + 1, envp);
            d = strtok(NULL, ":");
        }
        perror(argv[1]);
    } else {
        if (execve(argv[1], argv + 1, envp) == -1)
            perror(argv[1]);
    }
}
